﻿<?php

/**
 * (c) 2004-2007 Linbox / Free&ALter Soft, http://linbox.com
 * (c) 2007-2011 Mandriva, http://www.mandriva.com 
 * (c) 2012 Osinit, http://www.osinit.ru
 *  
 * $Id$
 *
 * This file is part of Mandriva Management Console (MMC).
 *
 * MMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MMC.  If not, see <http://www.gnu.org/licenses/>.
 */

require_once("modules/ppolicy/includes/ppolicyQuality.inc.php");
require_once("includes/FormHandler.php");
require("modules/base/users/localSidebar.php");
require("graph/navbar.inc.php");

global $errorStatus;
$error = "";
$result = "";

// Class managing $_POST array
if($_POST) {
    $FH = new FormHandler("qualityPPolicyFH", $_POST);
}
else {
    $FH = new FormHandler("qualityPPolicyFH", array());
}

$mode = "edit";
$title = _T("Edit password quality check rules", "ppolicy");
$sidemenu->forceActiveItem("qualityppolicy");
$FH->setArr(getAllPPolicyQualityAttributes());

if ($_POST) {
    $must_one_number = $FH->getPostValue("must_one_number");
    $must_one_upper_case = $FH->getPostValue("must_one_upper_case");
    $must_one_lower_case = $FH->getPostValue("must_one_lower_case");
    $must_one_special = $FH->getPostValue("must_one_special");
    $same_char_max = $FH->getPostValue("same_char_max");
    $use_cracklib = $FH->getPostValue("use_cracklib");
    // Some sanity checks...
    if ($FH->isUpdated("same_char_max")) {
        if ($same_char_max < 1) {
            $error .= _T('"Same char max" must be greater than 0.', 'ppolicy') . "<br />";
            setFormError("same_char_max");
        }
    }

    if (!$error && !isXMLRPCError()) {
        $ppolicyattr = getPPolicyQualityAttributesKeys();
        $update = "";
        foreach ($ppolicyattr as $attr => $info) { 
            if ($FH->isUpdated($attr) && $info[1] == "bool") {
                if ($FH->getValue($attr) == "on") $value = "True";
                if ($FH->getValue($attr) == "off") $value = "False";
                setPPolicyQualityAttribute($attr, $value);
                $update .= "<li>" . $info[0] . "</li>";
            }
            else if ($FH->isUpdated($attr)) {
                setPPolicyQualityAttribute($attr, $FH->getValue($attr), $name);
                $update .= "<li>" . $info[0] . "</li>";
            }
        }
        if ($update)
            $result .= _T("Attributes updated", "ppolicy") . ": <ul>" . $update . "</ul>";
    }

    if ($error)
        new NotifyWidgetFailure($error);
    if (isXMLRPCError())
        $FH->isError(true);
    else {
        $FH->isError(false);
        if ($result)
            new NotifyWidgetSuccess($result);
        header("Location: ". urlStrRedirect("base/users/qualityppolicy", array("ppolicy" => $name)));
    }
}

$p = new PageGenerator($title);
$p->setSideMenu($sidemenu);
$p->display();

$f = new ValidatingForm();

$f->push(new Table());

if ($FH->getArrayOrPostValue("must_one_number") == 'TRUE' ||
    $FH->getArrayOrPostValue("must_one_number") == 'on') {
    $must_one_number = "checked";
} else {
    $must_one_number = "";
}

$f->add(new TrFormElement(
        _T("Must contain at least one number", "ppolicy"),
        new CheckboxTpl("must_one_number"),
        array("tooltip" => ppolicyQualityTips("must_one_number"))
    ),
    array("value" => $must_one_number)
);

if ($FH->getArrayOrPostValue("must_one_upper_case") == 'TRUE' ||
    $FH->getArrayOrPostValue("must_one_upper_case") == 'on') {
    $must_one_upper_case = "checked";
} else {
    $must_one_upper_case = "";
}

$f->add(new TrFormElement(
        _T("Must contain at least one upper case character", "ppolicy"),
        new CheckboxTpl("must_one_upper_case"),
        array("tooltip" => ppolicyQualityTips("must_one_upper_case"))
    ),
    array("value" => $must_one_upper_case)
);


if ($FH->getArrayOrPostValue("must_one_lower_case") == 'TRUE' ||
    $FH->getArrayOrPostValue("must_one_lower_case") == 'on') {
    $must_one_lower_case = "checked";
} else {
    $must_one_lower_case = "";
}

$f->add(new TrFormElement(
        _T("Must contain at least one lower case character", "ppolicy"),
        new CheckboxTpl("must_one_lower_case"),
        array("tooltip" => ppolicyQualityTips("must_one_lower_case"))
    ),
    array("value" => $must_one_lower_case)
);

if ($FH->getArrayOrPostValue("must_one_special") == 'TRUE' ||
    $FH->getArrayOrPostValue("must_one_special") == 'on') {
    $must_one_special = "checked";
} else {
    $must_one_special = "";
}

$f->add(new TrFormElement(
        _T("Must contain at least one special character: #$%&+./:=?@{}", "ppolicy"),
        new CheckboxTpl("must_one_special"),
        array("tooltip" => ppolicyQualityTips("must_one_special"))
    ),
    array("value" => $must_one_special)
);

$f->add(new TrFormElement(
        _T("Maximum number of identical characters", "ppolicy"),
        new InputTpl("same_char_max",'/^[0-9]*$/'),
        array("tooltip" => ppolicyQualityTips("same_char_max"))
    ),
    array("value" => $FH->getArrayOrPostValue("same_char_max"))
);

if ($FH->getArrayOrPostValue("use_cracklib") == 'TRUE' ||
    $FH->getArrayOrPostValue("use_cracklib") == 'on') {
    $use_cracklib = "checked";
} else {
    $use_cracklib = "";
}

$f->add(new TrFormElement(
        _T("Test the password against cracklib", "ppolicy"),
        new CheckboxTpl("use_cracklib"),
        array("tooltip" => ppolicyQualityTips("use_cracklib"))
    ),
    array("value" => $use_cracklib)
);


$f->pop();

$f->addValidateButton("bppolicy");

$f->pop();

$f->display();
?>
