<?php

/**
 * (c) 2004-2007 Linbox / Free&ALter Soft, http://linbox.com
 * (c) 2007-2010 Mandriva, http://www.mandriva.com 
 * (c) 2012 Osinit, http://www.osinit.ru $Id$
 *
 * This file is part of Mandriva Management Console (MMC).
 *
 * MMC is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * MMC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MMC.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Declare all modifiable password quality check rules :
 * variable name associated tuple : 
 *      - usual name
 *      - variable type
 *
 * It's use to work on right variable among $_POST array.
 * It doesn't set form's input field !
 *
 */

function getPPolicyQualityAttributesKeys() {
    return array(   "must_one_number"          => array(_T("Must contain at least one number", "ppolicy"), "bool"),
                    "must_one_upper_case"      => array(_T("Must contain at least one upper case character", "ppolicy"), "bool"),
                    "must_one_lower_case"      => array(_T("Must contain at least one lower case character", "ppolicy"), "bool"),
                    "must_one_special"         => array(_T("Must contain at least one special character: #$%&+./:=?@{}", "ppolicy"), "bool"),
                    "same_char_max"            => array(_T("Maximum number of identical characters", "ppolicy"), "int"),
                    "use_cracklib"             => array(_T("Test the password against cracklib", "ppolicy"), "bool"),
                    );
}

function ppolicyQualityTips($attr) {
    $tips = array(
                  "must_one_number"  => _T("The password must contain at least one number", "ppolicy"),
                  "must_one_upper_case"  => _T("The password must contain at least one upper case character", "ppolicy"),
                  "must_one_lower_case"  => _T("The password must contain at least one lower case character", "ppolicy"),
                  "must_one_special"  => _T("The password must contain at least one special character: #$%&+./:=?@{}", "ppolicy"),
                  "same_char_max"  => _T("The maximum of identical characters in password", "ppolicy"),
                  "use_cracklib"  => _T("Test the password against cracklib (python-cracklib must be installed)", "ppolicy"),
                  );
    return $tips[$attr];
}

$x = "Password quality check rules";
?>